<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");
include("./plugins/update/functions.php");

include("./include/top_header.php");




/* tab information */
$ptabs = array(
	"current" => "Current",
	"updates" => "Updates",
);

	/* set the default settings category */
	if (!isset($_GET["tab"])) {
		/* there is no selected tab; select the first one */
		$current_tab = array_keys($ptabs);
		$current_tab = $current_tab[0];
	}else{
		$current_tab = $_GET["tab"];
	}

	/* draw the categories tabs on the top of the page */
	print "<table class='tabs' width='98%' cellspacing='0' cellpadding='3' align='center'><tr>\n";

	if (sizeof($ptabs) > 0) {
	foreach (array_keys($ptabs) as $tab_short_name) {
		print "<td " . (($tab_short_name == $current_tab) ? "bgcolor='silver'" : "bgcolor='#DFDFDF'") . " nowrap='nowrap' width='" . (strlen($ptabs[$tab_short_name]) * 9) . "' align='center' class='tab'>
				<span class='textHeader'><a href='update.php?tab=$tab_short_name'>$ptabs[$tab_short_name]</a></span>
				</td>\n
				<td width='1'></td>\n";
	}
	}

	print "<td></td>\n</tr></table>\n";

	html_start_box("<strong>Plugins (" . $ptabs[$current_tab] . ")</strong>", "98%", $colors["header"], "3", "center", "");

	print "<tr><td><table width='100%'>";

	update_info_table();

	switch ($current_tab) {
		case 'current':
			update_show_current();
			break;
		case 'updates':
			update_show_updates();
			break;
		default:
			print '<br><br><br>';
	}

	$last_check = read_config_option("plugin_update_last_check");
	if ($last_check < 1)
		$last_check = 0;

	print "<center>Last Scanned : " . ($last_check > 0 ? date("F j, Y g:i:s a", $last_check) : "Never") . "</center>";

	print "</table></td></tr>";

	html_end_box();

	include("./include/bottom_footer.php");

function update_show_updates () {
	global $plugins, $colors, $config, $plugin_architecture;

	$cinfo = array();
	sort($plugins);

	$cinfo = update_get_plugin_info ();

	$x = 0;

	$info = update_get_cached_plugin_info();

	$cactinew = update_check_if_newer($cinfo['cacti']['version'], $info['cacti']['version']) ;
	if (isset($cinfo['cacti_plugin_arch']['version']))
		$archnew =  update_check_if_newer($cinfo['cacti_plugin_arch']['version'], $info['cacti_plugin_arch']['version']);
	else
		$archnew = 0;

	if ($cactinew) {
		$x++;
		print "<tr><td width='25%' valign=top><table width='100%'>";
		html_header(array("Cacti"), 2);
		form_alternate_row_color($colors["alternate"],$colors["light"], 0);
		print "<td width='25%'><strong>Version:</strong></td><td>" . $config["cacti_version"] . "</td></tr>";
		form_alternate_row_color($colors["alternate"],$colors["light"], 0);
		print "<td valign=top><strong>Changes:</strong></td><td>" . str_replace("\n", '<br>', $info['cacti']['changes']) . "</td></tr></table>";
	}
	if (isset($plugin_architecture['version']) && $archnew) {
		$x++;
		print "<table width='100%'>";
		html_header(array("Plugin Architecture"), 2);
		form_alternate_row_color($colors["alternate"],$colors["light"], 0);
		print "<td width='25%'><strong>Version:</strong></td><td>" . $plugin_architecture['version'] . "</td>";
		form_alternate_row_color($colors["alternate"],$colors["light"], 0);
		print "<td valign=top><strong>Changes:</strong></td><td>" . str_replace("\n", '<br>', $info['cacti_plugin_arch']['changes']) . "</td></tr></table>";
	}
	print "<table width='100%' cellspacing=0 cellpadding=3>";

	foreach ($plugins as $plugin) {
		if (isset($cinfo[$plugin]) && update_check_if_newer($cinfo[$plugin]['version'], $info[$plugin]['version'])) {
			$x++;
			print "<table width='100%'>";
			html_header(array((isset($cinfo[$plugin]['longname']) ? $cinfo[$plugin]['longname'] : $plugin)), 2);
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td width='50%'><strong>Directory:</strong></td><td>$plugin</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Version:</strong></td><td>" . $info[$plugin]['version'] . "</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Author:</strong></td><td>" . (isset($cinfo[$plugin]['author']) && $cinfo[$plugin]['author'] != '' ? (isset($cinfo[$plugin]['email']) && $cinfo[$plugin]['email'] != '' ? "<a href='mailto:" . $cinfo[$plugin]['email'] . "'>" . $cinfo[$plugin]['author'] . "</a>"  : $cinfo[$plugin]['author']) : "") . "</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Home Page:</strong></td><td>" . (isset($cinfo[$plugin]['homepage']) && $cinfo[$plugin]['homepage'] != '' ? "<a href='" . $cinfo[$plugin]['homepage'] . "'>" . $cinfo[$plugin]['homepage'] . "</a>" : "") . "</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td valign=top><strong>Changes:</strong></td><td>" . str_replace("\n", '<br>', $info[$plugin]['changes']) . "</td>";

			print "</tr></table>";
		}
	}
	if ($x == 0)
		print "<br><center><b>There are currently no Updates!</b></center><br>";
	print "</table>";
	html_end_box(TRUE);
}

function update_show_current () {
	global $plugins, $colors, $plugin_architecture, $config;

	$cinfo = array();
	sort($plugins);

	$cinfo = update_get_plugin_info ();
	$info = update_get_cached_plugin_info();

	print "<table width='100%' cellspacing=0 cellpadding=3>";
	print "<tr><td width='50%'><table width='100%'>";
	html_header(array("Cacti"), 2);
	form_alternate_row_color($colors["alternate"],$colors["light"], 0);
	print "<td width='50%'><strong>Version:</strong></td><td>" . $config["cacti_version"] . (update_check_if_newer($cinfo['cacti']['version'], $info['cacti']['version']) ?  ' - <font color=red><b>(Update Available!)</strong></font>' : '') . "</td></tr></table>";
	print "</td><td>";
	if (isset($plugin_architecture['version'])) {
		print "<table width='100%'>";
		html_header(array("Plugin Architecture"), 2);
		form_alternate_row_color($colors["alternate"],$colors["light"], 0);
		print "<td width='50%'><strong>Version:</strong></td><td>" . $plugin_architecture['version'] . (update_check_if_newer($cinfo['cacti_plugin_arch']['version'], $info['cacti_plugin_arch']['version']) ?  ' - <font color=red><b>(Update Available!)</strong></font>' : '') . "</td></tr></table>";
	}
	print "</td></tr></table>";

	print "<table width='100%' cellspacing=0 cellpadding=3>";
	$x = 0;

	foreach ($plugins as $plugin) {
		if (isset($cinfo[$plugin])) {

			if ($x == 0) {
				print "<tr><td width='50%'>";
			} else {
				print "</td><td>";
			}
			if (!isset($info[$plugin]['version']))
				$info[$plugin]['version'] = '';

			print "<table width='100%'>";
			html_header(array((isset($cinfo[$plugin]['longname']) ? $cinfo[$plugin]['longname'] : $plugin)), 2);
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td width='50%'><strong>Directory:</strong></td><td>$plugin</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Version:</strong></td><td>" . (isset($cinfo[$plugin]['version']) ? $cinfo[$plugin]['version'] : "") . (update_check_if_newer($cinfo[$plugin]['version'], $info[$plugin]['version']) ?  ' - <font color=red><b>(Update Available!)</strong></font>' : '') . "</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Author:</strong></td><td>" . (isset($cinfo[$plugin]['author']) && $cinfo[$plugin]['author'] != '' ? (isset($cinfo[$plugin]['email']) && $cinfo[$plugin]['email'] != '' ? "<a href='mailto:" . $cinfo[$plugin]['email'] . "'>" . $cinfo[$plugin]['author'] . "</a>"  : $cinfo[$plugin]['author']) : "") . "</td>";
			form_alternate_row_color($colors["alternate"],$colors["light"], 0);
			print "<td><strong>Home Page:</strong></td><td>" . (isset($cinfo[$plugin]['homepage']) && $cinfo[$plugin]['homepage'] != '' ? "<a href='" . $cinfo[$plugin]['homepage'] . "'>" . $cinfo[$plugin]['homepage'] . "</a>" : "") . "</td>";
			print "</tr></table>";
			if ($x == 1) {
				print "</td></tr>";
			}
			$x++;
			if ($x > 1) $x = 0;
		}
	}
	if ($x == 1)
		print "</td><td></td></tr>";
	print "</table>";
	html_end_box(TRUE);
}

?>